/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _PCALOPTIONS_H_
#define _PCALOPTIONS_H_
#include<gtkmm.h>

#if defined(_WIN32) 
// Create the Windows-based definitions
#include<libintl.h>
#endif

class PCalOptions
{
    public:
        PCalOptions();
        PCalOptions(Gtk::Window * mw);
        ~PCalOptions();

        PCalOptions& operator=(const PCalOptions& src);
    
        // path to the home dir
        Glib::ustring homepath;
    
        // options fields
        Glib::Date::Weekday firstDay;
        Glib::ustring toolbarStyle; /// one of System Default, Icons, Text, Both, Both Horizontal
        // new option placeholder
        Gdk::Color undefinedMonthBGColor;
        Gdk::Color undefinedMonthFGColor;
        Gdk::Color inactiveMonthBGColor;
        Gdk::Color inactiveMonthFGColor;
        Gdk::Color todayBGColor;
        Gdk::Color todayFGColor;
        Gdk::Color day1BGColor;
        Gdk::Color day1FGColor;
        Gdk::Color pday1BGColor;
        Gdk::Color pday1FGColor;
        Gdk::Color fertBGColor;
        Gdk::Color fertFGColor;
        Gdk::Color pfertBGColor;
        Gdk::Color pfertFGColor;
        Gdk::Color pregFGColor;
        Gdk::Color pregBGColor;
        Gdk::Color birthFGColor;
        Gdk::Color birthBGColor;
        Gdk::Color pbirthFGColor;
        Gdk::Color pbirthBGColor;
        int bufferDays;
        int badFeelDaysBefore;
        int badFeelDaysAfter;
        int regularMinLength;
        int regularMaxLength;
    
        void saveLocalOptions();
        void loadLocalOptions();
        void resetToDefaults();	
    private:
        Gtk::Window * mainWindow;
        Glib::ustring color_to_str(const Gdk::Color& color);
        void setKey(const Glib::ustring key, const Glib::ustring value);
};

#endif	//_PCALOPTIONS_H_
